#pragma semicolon 1

#include <sourcemod>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP Module (Kill HP)",
	author	= "wS",
	version = "1.1"
};

new const String:g_sItemName[] = "kill_hp";
new g_ItemID, g_KillHp[MAXPLAYERS + 1];

public OnPluginStart()
{
	if ((g_ItemID = VIP_RegisterItem(g_sItemName, true, true)) < 1)
		SetFailState("VIP_RegisterItem error");

	HookEvent("player_death", player_death, EventHookMode_Post);
}

public OnPluginEnd()
{
	VIP_UnRegisterItem(g_sItemName);
}

public OnClientConnected(client)
{
	g_KillHp[client] = 0;
}

public VIP_OnClientAuthorized(client, const String:steamid[], bool:vip, const String:group[])
{
	if (vip) wS_Check(client);
}

public VIP_OnVipItemToggled(client, ItemID, const String:ItemName[], const String:ItemInfo[], bool:enabled)
{
	if (ItemID == g_ItemID)
	{
		g_KillHp[client] = enabled ? StringToInt(ItemInfo) : 0;
		VIP_ShowMenu(client);
	}
}

public VIP_OnRemoved(client, const String:steamid[], const String:reason[])
{
	g_KillHp[client] = 0;
}

public VIP_OnGroupChanged(client, const String:steamid[], const String:OldGroup[], const String:NewGroup[])
{
	g_KillHp[client] = 0;
	wS_Check(client);
}

public VIP_OnAdded(client, const String:steamid[], const String:group[], min, const String:admin_steamid[])
{
	if (client > 0) wS_Check(client);
}

wS_Check(client)
{
	if (!VIP_ItemDisabled(g_sItemName) && VIP_GetItemToggledStatus(client, g_sItemName))
	{
		decl String:ItemInfo[MAX_ITEMINFO_LENGTH];
		if (VIP_GetClientItemInfo(client, g_sItemName, ItemInfo)) g_KillHp[client] = StringToInt(ItemInfo);
	}
}

public player_death(Handle:event, const String:name[], bool:silent)
{
	new killer = GetClientOfUserId(GetEventInt(event, "attacker"));
	if (killer > 0 && g_KillHp[killer] > 0 && GetClientTeam(killer) != GetClientTeam(GetClientOfUserId(GetEventInt(event, "userid"))))
	{
		SetEntProp(killer, Prop_Send, "m_iHealth", GetEntProp(killer, Prop_Send, "m_iHealth") + g_KillHp[killer]);
	}
}